unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, HexView, ActnList, Menus, ToolWin,
  ImgList;

type
  TMainForm = class(TForm)
    StatusBar: TStatusBar;
    MainMenu: TMainMenu;
    FileItem: TMenuItem;
    FileOpenItem: TMenuItem;
    HelpItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    FileCloseItem: TMenuItem;
    ActionList: TActionList;
    FileOpenAction: TAction;
    FileCloseAction: TAction;
    FileExitAction: TAction;
    OpenDialog: TOpenDialog;
    AcceptDropFiles1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FileExitActionExecute(Sender: TObject);
    procedure FileOpenActionExecute(Sender: TObject);
    procedure FileCloseActionExecute(Sender: TObject);
    procedure HelpAboutItemClick(Sender: TObject);
  private
    { Private-Deklarationen }
    FHexEdit: THexEdit;
  public
    { Public-Deklarationen }
    procedure UpdateActions; override;
    procedure OpenFile(AFilename: TFilename);
  end;

var
  MainForm: TMainForm;

  
implementation
{$R *.dfm}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  FHexEdit := THexEdit.Create(Self);
  FHexEdit.Parent := Self;
  FHexEdit.Align := alClient;
  FHexEdit.Options := [eoAcceptDropFiles];
  
  if ParamCount > 0 then
    if FileExists(ParamStr(1)) then 
      OpenFile(ParamStr(1));  
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  FHexEdit.CloseFile;
  StatusBar.Panels[0].Text := '';
end;

procedure TMainForm.UpdateActions;
begin
  inherited;

  FileCloseAction.Enabled := FHexEdit.IsShowingFile;
end;

procedure TMainForm.OpenFile(AFilename: TFilename);
begin
  FHexEdit.OpenFile(AFilename);
  StatusBar.Panels[0].Text := AFilename;
end;

procedure TMainForm.FileOpenActionExecute(Sender: TObject);
begin
  if OpenDialog.Execute then
  begin
    OpenFile(OpenDialog.FileName);
  end;
end;

procedure TMainForm.FileCloseActionExecute(Sender: TObject);
begin
  FHexEdit.CloseFile;
end;

procedure TMainForm.FileExitActionExecute(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.HelpAboutItemClick(Sender: TObject);
begin
  ShowMessage('Quick ''n Dirty hex-View hacked together by Peter Schraut (www.console-dev.de)');
end;

end.
